//
// BeInternetCentral
// EmailView class
//
// (c) 1997 Hubert Figuiere
// figuiere@kagi.com
//
// 27june1997
//
// 010797 HF


#include "app/BICApplication.h"
#include "app/BICWindow.h"
#include "app/BICCommands.h"
#include "app/EmailView.h"
#include "sdk/BICKeyNames.h"
#include "sdk/libbic.h"



/////////////////////////////////////////////////////
EmailView::EmailView(BRect frame)
	: TopicView(frame, "E-mail")
{
}


/////////////////////////////////////////////////////
void EmailView::AttachedToWindow(void)
{
	inherited::AttachedToWindow();
	BRect viewBounds = Bounds();
	BRect aRect;
	BMenuField * aMenuField;

	mPersonalityMenu = new BPopUpMenu("", true, true, B_ITEMS_IN_COLUMN);
	
	aRect.Set(10, 20, viewBounds.right - 10, 36);
	aMenuField = new BMenuField(aRect, "", "Personality :", mPersonalityMenu);
	mBox->AddChild(aMenuField);
	aMenuField->SetDivider(100.);	

	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mSMTPTextControl = new BTextControl(aRect, "", "SMTP Relay :", "", 
			BICWindow::MakeCommandMessage(SMTPRELAY_CHANGED));
	mBox->AddChild(mSMTPTextControl);		
	mSMTPTextControl->SetTarget(Window());
	mSMTPTextControl->SetDivider(100.);
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mPOPAccountTextControl = new BTextControl(aRect, "", "POP Account :", "", 
			BICWindow::MakeCommandMessage(POPACOUNT_CHANGED));
	mBox->AddChild(mPOPAccountTextControl);		
	mPOPAccountTextControl->SetTarget(Window());
	mPOPAccountTextControl->SetDivider(100.);

	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mPOPServerTextControl = new BTextControl(aRect, "", "POP Host :", "", 
			BICWindow::MakeCommandMessage(POPHOST_CHANGED));
	mBox->AddChild(mPOPServerTextControl);		
	mPOPServerTextControl->SetTarget(Window());
	mPOPServerTextControl->SetDivider(100.);
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mPOPPasswordTextControl = new BTextControl(aRect, "", "POP Password :", "", 
			BICWindow::MakeCommandMessage(POPPASSWORD_CHANGED));
	mBox->AddChild(mPOPPasswordTextControl);		
	mPOPPasswordTextControl->SetTarget(Window());
	mPOPPasswordTextControl->SetDivider(100.);

	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	aRect.right = (viewBounds.right / 2) - 2;
	mPasswdRadioButton = new BRadioButton(aRect, "PASSWORD", "Password",
			BICWindow::MakeCommandMessage(POPAUTHENT_CHANGED));	
	mBox->AddChild(mPasswdRadioButton);
	mPasswdRadioButton->SetTarget(Window());
	mPasswdRadioButton->SetValue(1.0);
	
	aRect.left = aRect.right + 2;
	aRect.right = viewBounds.right - 2;
	mAPOPRadioButton = new BRadioButton(aRect, "APOP", "APOP",
			BICWindow::MakeCommandMessage(POPAUTHENT_CHANGED));	
	mBox->AddChild(mAPOPRadioButton);
	mAPOPRadioButton->SetTarget(Window());

	TopicView::ReloadPersonalityList(mPersonalityMenu, mCurrentPersonality);
}



/////////////////////////////////////////////////////
void EmailView::CurrentPersonalityChanged(BMessage * /*msg*/)
{
	ReloadEmailConfig();
}


/////////////////////////////////////////////////////
void EmailView::ReloadEmailConfig()
{
	status_t err;
	ssize_t size = 256;
	key_value value = (key_value)malloc((size + 1) * sizeof(char));
	if (value == NULL) {
		debugger("out of memory");
		return;
	}

	err = TopicView::LoadKeyIntoTextControl(mPOPAccountTextControl, KEY_POP_USERNAME,
						mCurrentPersonality, value, size);
	err = TopicView::LoadKeyIntoTextControl(mPOPServerTextControl, KEY_POP_HOST,
						mCurrentPersonality, value, size);
	err = TopicView::LoadKeyIntoTextControl(mPOPPasswordTextControl, KEY_POP_PASSWORD,
						mCurrentPersonality, value, size);
	err = TopicView::LoadKeyIntoTextControl(mSMTPTextControl, KEY_SMTP_HOST,
						mCurrentPersonality, value, size);
}


/////////////////////////////////////////////////////
