//
// BeInternetCentral
// Personality class
//
// (c) 1997 Hubert Figuiere
// figuiere@kagi.com
//
// 27june1997
//
// version 0.6 - 24July1997
//	-added basic Personality management



#include "app/BICApplication.h"
#include "app/BICWindow.h"
#include "app/BICCommands.h"
#include "app/PersonalityView.h"



/////////////////////////////////////////////////////
PersonalityView::PersonalityView(BRect frame)
	: TopicView(frame, "Personality")
{
}



/////////////////////////////////////////////////////
void PersonalityView::AttachedToWindow(void)
{
	inherited::AttachedToWindow();
	BRect viewBounds = Bounds();
	BRect aRect;
	BRect anotherRect;
	BButton * aButton;
	BCheckBox * aCheckBox;
	BMenuField * aMenuField;

	mPersonalityMenu = new BPopUpMenu("", true, true, B_ITEMS_IN_COLUMN);
	
	aRect.Set(10, 20, viewBounds.right - 10, 36);
	anotherRect = aRect;
	anotherRect.right = (viewBounds.right / 2) - 5;
	aMenuField = new BMenuField(anotherRect, "", "Personality :", mPersonalityMenu);
	mBox->AddChild(aMenuField);
	aMenuField->SetDivider(75.);	
	
	anotherRect.left = anotherRect.right + 10.;
	anotherRect.right = anotherRect.left + 25;
	aButton = new BButton(anotherRect, "", "+", BICWindow::MakeCommandMessage(ADD_PERSONALITY));
	mBox->AddChild(aButton);
	aButton->SetTarget(Window());

	anotherRect.left = anotherRect.right + 10.;
	anotherRect.right = anotherRect.left + 25;
	aButton = new BButton(anotherRect, "", "-", BICWindow::MakeCommandMessage(REMOVE_PERSONALITY));
	mBox->AddChild(aButton);
	aButton->SetTarget(Window());
	
	anotherRect.left = anotherRect.right + 10.;
	anotherRect.right = anotherRect.left + 75;
	aCheckBox = new BCheckBox(anotherRect, "", "Default", BICWindow::MakeCommandMessage(DEFAULT_PERSONALITY));
	mBox->AddChild(aCheckBox);
	aCheckBox->SetTarget(Window());
	
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mNameTextControl = new BTextControl(aRect, "", "Name :", "", 
			BICWindow::MakeCommandMessage(NAME_CHANGED));
	mBox->AddChild(mNameTextControl);		
	mNameTextControl->SetTarget(Window());
	mNameTextControl->SetDivider(100.);
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mEmailAddressTextControl = new BTextControl(aRect, "", "E-mail :", "", 
			BICWindow::MakeCommandMessage(EMAIL_CHANGED));
	mBox->AddChild(mEmailAddressTextControl);		
	mEmailAddressTextControl->SetTarget(Window());
	mEmailAddressTextControl->SetDivider(100.);
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mOrganizationTextControl = new BTextControl(aRect, "", "Organization :", "", 
			BICWindow::MakeCommandMessage(ORGANIZATION_CHANGED));
	mBox->AddChild(mOrganizationTextControl);		
	mOrganizationTextControl->SetTarget(Window());
	mOrganizationTextControl->SetDivider(100.);

	TopicView::ReloadPersonalityList(mPersonalityMenu, mCurrentPersonality);
}



/////////////////////////////////////////////////////
void PersonalityView::CurrentPersonalityChanged(BMessage * /*msg*/)
{
	ReloadPersonalityConfig();	
}





/////////////////////////////////////////////////////
void PersonalityView::ReloadPersonalityConfig()
{
	status_t err;
	ssize_t size = 256;
	ssize_t realSize;
	key_value value = (key_value)malloc((size + 1) * sizeof(char));
	if (value == NULL) {
		debugger("out of memory");
		return;
	}

	/*real name*/
	err = TopicView::LoadKeyIntoTextControl(mNameTextControl, KEY_REAL_NAME,
						mCurrentPersonality, value, size);
	/*email address*/
	err = TopicView::LoadKeyIntoTextControl(mEmailAddressTextControl, KEY_EMAIL_ADRESS,
						mCurrentPersonality, value, size);
	/*organization*/
	err = TopicView::LoadKeyIntoTextControl(mOrganizationTextControl, KEY_ORGANIZATION,
						mCurrentPersonality, value, size);
}


/////////////////////////////////////////////////////
