//
//
// BeInternetCentral Lib
//
// ©1997 Hubert Figuière
//
// May 26th 1997
//
// BICRegistry : the class that manages a registry


#include "sdk/libbic.h"
#include "lib/BICRegistry.h"
#include "lib/BICInternals.h"




////////////////////////////////////////////////////////////
status_t BICRegistry::InitCheck(void)
{
	return _private_datas_->InitCheck();
}

////////////////////////////////////////////////////////////
status_t BICRegistry::GetKey(const key_id id, const key_attribute_id attribute, key_value value, ssize_t & size)
{
	return _private_datas_->GetKey(id, attribute, value, size);
}


////////////////////////////////////////////////////////////
status_t BICRegistry::SetKey(const key_id id, const key_attribute_id attribute, const key_value value)
{
	return _private_datas_->SetKey(id, attribute, value);
}


////////////////////////////////////////////////////////////
status_t BICRegistry::DeleteKey(const key_id id, const key_attribute_id attribute)
{
	return _private_datas_->DeleteKey(id, attribute);
}

#pragma mark -

////////////////////////////////////////////////////////////
status_t BICRegistry::CountPersonality(int32 & count)
{
	return _private_datas_->CountPersonality(count);
}


////////////////////////////////////////////////////////////
char * BICRegistry::GetDefaultPersonality() const
{
	return _private_datas_->GetDefaultPersonality();
}


////////////////////////////////////////////////////////////
status_t BICRegistry::SetDefaultPersonality(const key_attribute_id personality)
{
	return _private_datas_->SetDefaultPersonality(personality);
}


////////////////////////////////////////////////////////////
status_t BICRegistry::GetPersonality(const int32 index, key_attribute_id personality, ssize_t & size) const
{
	return _private_datas_->GetPersonality(index, personality, size);
}


////////////////////////////////////////////////////////////
status_t BICRegistry::AddPersonality(const key_attribute_id personality)
{
	return _private_datas_->AddPersonality(personality);
}


////////////////////////////////////////////////////////////
status_t BICRegistry::DeletePersonality(const key_attribute_id personality)
{
	return _private_datas_->DeletePersonality(personality);
}


#pragma mark -

////////////////////////////////////////////////////////////
status_t BICRegistry::SetRegPath(const char * path, const char * name)
{
	return _private_datas_->SetRegPath(path, name);
}


////////////////////////////////////////////////////////////
status_t BICRegistry::GetRegPath(const char * path, char * name)
{
	return _private_datas_->GetRegPath(path, name);
}



////////////////////////////////////////////////////////////
status_t BICRegistry::ResetRegPath(void)
{
	return _private_datas_->ResetRegPath();
}


////////////////////////////////////////////////////////////
status_t BICRegistry::SaveRegistry(void)
{
	return _private_datas_->SaveRegistry();
}


#pragma mark -


////////////////////////////////////////////////////////////
BICRegistry::BICRegistry()
{
	_private_datas_ = new BICInternals;
}


////////////////////////////////////////////////////////////
BICRegistry::~BICRegistry()
{
	delete _private_datas_;
}

#pragma mark -

////////////////////////////////////////////////////////////
bool BICRegistry::Lock()
{
	return _private_datas_->Lock();
}


////////////////////////////////////////////////////////////
void BICRegistry::Unlock()
{
	_private_datas_->Unlock();
}


////////////////////////////////////////////////////////////
bool BICRegistry::IsLocked()
{
	return _private_datas_->IsLocked();
}


////////////////////////////////////////////////////////////
