//
//
// BeInternetCentral Lib
//
// ©1997 Hubert Figuière
//
// May 26th 1997


#include "lib/libbic.internals.h"
#include "lib/BICInternals.h"


/* Real version nmuber of the library */ 
bic_version _BIC_CURRENT_VERSION_ = 5;

char * _BIC_DEFAULT_REGISTRY_NAME_ = "BeInternetCentral registry";


#pragma export on


///////////////////////////////////////////////////////////////
status_t create_bic_registry(BICRegistry * & registry, bic_version & vers)
{
	//doc
	if (vers != _BIC_CURRENT_VERSION_) {
		vers = _BIC_CURRENT_VERSION_;
		printf("Wrong version\n");
		return BIC_VERSION_NOT_AVAILABLE;
	}
	registry = new BICRegistry;
	return registry->InitCheck();
}


///////////////////////////////////////////////////////////////
/*
	Dispose the registry
*/
status_t dispose_bic_registry(BICRegistry * & registry)
{
	//doc
	if (!registry->Lock()) {
		return B_BAD_VALUE;
	}
	registry->Unlock();

	delete registry;
	registry = NULL;
	return B_NO_ERROR;
}

#pragma export reset

///////////////////////////////////////////////////////////////
